VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4845
   ClientLeft      =   2010
   ClientTop       =   1860
   ClientWidth     =   5430
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4845
   ScaleWidth      =   5430
   Begin VB.ListBox lstFiles 
      Height          =   3765
      Left            =   0
      TabIndex        =   5
      Top             =   840
      Width           =   5415
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Text            =   "*.jpg"
      Top             =   480
      Width           =   2055
   End
   Begin VB.TextBox txtStartDir 
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Text            =   "C:\"
      Top             =   120
      Width           =   2055
   End
   Begin VB.Label lblNumFiles 
      Alignment       =   2  'Center
      Caption         =   "0 Files"
      Height          =   255
      Left            =   3360
      TabIndex        =   6
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Pattern"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Start directory"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1

Private Sub cmdSearch_Click()
Dim start_dir As String
Dim pattern As String

    start_dir = Trim$(txtStartDir.Text)
    If Right$(start_dir, 1) = "\" Then _
        start_dir = _
            Left$(start_dir, Len(start_dir) - 1)
    pattern = Trim$(txtPattern.Text)
    ListFiles start_dir, pattern, lstFiles

    lblNumFiles.Caption = Format$(lstFiles.ListCount & " files")
End Sub
' List all files below the directory that
' match the pattern.
Private Sub ListFiles(ByVal start_dir As String, ByVal pattern As String, ByVal lst As ListBox)
Dim dir_names() As String
Dim num_dirs As Integer
Dim i As Integer
Dim fname As String
Dim attr As Integer

    ' Protects against such things as
    ' GetAttr("C:\pagefile.sys").
    On Error Resume Next
    
    ' Get the matching files in this directory.
    fname = Dir(start_dir & "\" & pattern, vbNormal)
    Do While fname <> ""
        lst.AddItem start_dir & "\" & fname
        fname = Dir()
    Loop

    ' Get the list of subdirectories.
    fname = Dir(start_dir & "\*.*", vbDirectory)
    Do While fname <> ""
        ' Skip this dir and its parent.
        attr = 0    ' In case there's an error.
        attr = GetAttr(start_dir & "\" & fname)
        If fname <> "." And fname <> ".." And _
            (attr And vbDirectory) <> 0 _
        Then
            num_dirs = num_dirs + 1
            ReDim Preserve dir_names(1 To num_dirs)
            dir_names(num_dirs) = fname
        End If
        fname = Dir()
    Loop

    ' Search the other directories.
    For i = 1 To num_dirs
        ListFiles start_dir & "\" & dir_names(i), pattern, lst
    Next i
End Sub

Private Sub Form_Load()
    txtStartDir.SelStart = Len(txtStartDir.Text)
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - cmdSearch.Top
    If hgt < 120 Then hgt = 120
    lstFiles.Move 0, lstFiles.Top, ScaleWidth, hgt
End Sub


' Open the double-clicked file.
Private Sub lstFiles_DblClick()
    ShellExecute Me.hwnd, "open", lstFiles.Text, _
        vbNullString, vbNullString, SW_SHOWNORMAL
End Sub


